<?php
/**
 * The template part for displaying a message that posts cannot be found.
 */
?>


<div class="entry-content">

    <h3><?php _e( 'No hay resultados', 'wpzoom' ); ?></h3>

    <?php if ( is_home() && current_user_can( 'publish_posts' ) ) : ?>

        <p><?php printf( __( '¿Preparado para tu primera publicación? <a href="%1$s">Comienza aquí</a>.', 'wpzoom' ), esc_url( admin_url( 'post-new.php' ) ) ); ?></p>

    <?php elseif ( is_search() ) : ?>

        <p><?php _e( 'Lo sentimos, no hay resultados para tú búsqueda. Inténtalo de nuevo con otras palabras.', 'wpzoom' ); ?></p>
        <?php get_search_form(); ?>

    <?php else : ?>

        <p><?php _e( 'Parece que no encontramos lo que buscabas. Inténtalo de nuevo', 'wpzoom' ); ?></p>
        <?php get_search_form(); ?>

    <?php endif; ?>
</div><!-- .entry-content -->
